/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableTrip {
  TripAlarmType_EventId((int) 10752L),
  TripAlarmType_EventType((int) 10753L),
  TripAlarmType_SourceNode((int) 10754L),
  TripAlarmType_SourceName((int) 10755L),
  TripAlarmType_Time((int) 10756L),
  TripAlarmType_ReceiveTime((int) 10757L),
  TripAlarmType_LocalTime((int) 10758L),
  TripAlarmType_Message((int) 10759L),
  TripAlarmType_Severity((int) 10760L),
  TripAlarmType_ConditionName((int) 10761L),
  TripAlarmType_BranchId((int) 10762L),
  TripAlarmType_Retain((int) 10763L),
  TripAlarmType_EnabledState((int) 10764L),
  TripAlarmType_EnabledState_Id((int) 10765L),
  TripAlarmType_EnabledState_Name((int) 10766L),
  TripAlarmType_EnabledState_Number((int) 10767L),
  TripAlarmType_EnabledState_EffectiveDisplayName((int) 10768L),
  TripAlarmType_EnabledState_TransitionTime((int) 10769L),
  TripAlarmType_EnabledState_EffectiveTransitionTime((int) 10770L),
  TripAlarmType_EnabledState_TrueState((int) 10771L),
  TripAlarmType_EnabledState_FalseState((int) 10772L),
  TripAlarmType_Quality((int) 10773L),
  TripAlarmType_Quality_SourceTimestamp((int) 10774L),
  TripAlarmType_LastSeverity((int) 10775L),
  TripAlarmType_LastSeverity_SourceTimestamp((int) 10776L),
  TripAlarmType_Comment((int) 10777L),
  TripAlarmType_Comment_SourceTimestamp((int) 10778L),
  TripAlarmType_ClientUserId((int) 10779L),
  TripAlarmType_AddComment_InputArguments((int) 10783L),
  TripAlarmType_ConditionRefresh_InputArguments((int) 10785L),
  TripAlarmType_AckedState((int) 10786L),
  TripAlarmType_AckedState_Id((int) 10787L),
  TripAlarmType_AckedState_Name((int) 10788L),
  TripAlarmType_AckedState_Number((int) 10789L),
  TripAlarmType_AckedState_EffectiveDisplayName((int) 10790L),
  TripAlarmType_AckedState_TransitionTime((int) 10791L),
  TripAlarmType_AckedState_EffectiveTransitionTime((int) 10792L),
  TripAlarmType_AckedState_TrueState((int) 10793L),
  TripAlarmType_AckedState_FalseState((int) 10794L),
  TripAlarmType_ConfirmedState((int) 10795L),
  TripAlarmType_ConfirmedState_Id((int) 10796L),
  TripAlarmType_ConfirmedState_Name((int) 10797L),
  TripAlarmType_ConfirmedState_Number((int) 10798L),
  TripAlarmType_ConfirmedState_EffectiveDisplayName((int) 10799L),
  TripAlarmType_ConfirmedState_TransitionTime((int) 10800L),
  TripAlarmType_ConfirmedState_EffectiveTransitionTime((int) 10801L),
  TripAlarmType_ConfirmedState_TrueState((int) 10802L),
  TripAlarmType_ConfirmedState_FalseState((int) 10803L),
  TripAlarmType_Acknowledge_InputArguments((int) 10805L),
  TripAlarmType_Confirm_InputArguments((int) 10807L),
  TripAlarmType_ActiveState((int) 10808L),
  TripAlarmType_ActiveState_Id((int) 10809L),
  TripAlarmType_ActiveState_Name((int) 10810L),
  TripAlarmType_ActiveState_Number((int) 10811L),
  TripAlarmType_ActiveState_EffectiveDisplayName((int) 10812L),
  TripAlarmType_ActiveState_TransitionTime((int) 10813L),
  TripAlarmType_ActiveState_EffectiveTransitionTime((int) 10814L),
  TripAlarmType_ActiveState_TrueState((int) 10815L),
  TripAlarmType_ActiveState_FalseState((int) 10816L),
  TripAlarmType_SuppressedState((int) 10817L),
  TripAlarmType_SuppressedState_Id((int) 10818L),
  TripAlarmType_SuppressedState_Name((int) 10819L),
  TripAlarmType_SuppressedState_Number((int) 10820L),
  TripAlarmType_SuppressedState_EffectiveDisplayName((int) 10821L),
  TripAlarmType_SuppressedState_TransitionTime((int) 10822L),
  TripAlarmType_SuppressedState_EffectiveTransitionTime((int) 10823L),
  TripAlarmType_SuppressedState_TrueState((int) 10824L),
  TripAlarmType_SuppressedState_FalseState((int) 10825L),
  TripAlarmType_ShelvingState_CurrentState((int) 10827L),
  TripAlarmType_ShelvingState_CurrentState_Id((int) 10828L),
  TripAlarmType_ShelvingState_CurrentState_Name((int) 10829L),
  TripAlarmType_ShelvingState_CurrentState_Number((int) 10830L),
  TripAlarmType_ShelvingState_CurrentState_EffectiveDisplayName((int) 10831L),
  TripAlarmType_ShelvingState_LastTransition((int) 10832L),
  TripAlarmType_ShelvingState_LastTransition_Id((int) 10833L),
  TripAlarmType_ShelvingState_LastTransition_Name((int) 10834L),
  TripAlarmType_ShelvingState_LastTransition_Number((int) 10835L),
  TripAlarmType_ShelvingState_LastTransition_TransitionTime((int) 10836L),
  TripAlarmType_ShelvingState_UnshelveTime((int) 10837L),
  TripAlarmType_ShelvingState_TimedShelve_InputArguments((int) 10862L),
  TripAlarmType_SuppressedOrShelved((int) 10863L),
  TripAlarmType_MaxTimeShelved((int) 10864L),
  TripAlarmType_ConditionClassId((int) 11159L),
  TripAlarmType_ConditionClassName((int) 11160L),
  TripAlarmType_InputNode((int) 11161L),
  TripAlarmType_NormalState((int) 11162L),
  TripAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime((int) 11483L),
  TripAlarmType_ConditionRefresh2_InputArguments((int) 13011L),
  TripAlarmType_ConditionSubClassId((int) 17008L),
  TripAlarmType_ConditionSubClassName((int) 17009L),
  TripAlarmType_OutOfServiceState((int) 17010L),
  TripAlarmType_OutOfServiceState_Id((int) 17011L),
  TripAlarmType_OutOfServiceState_Name((int) 17012L),
  TripAlarmType_OutOfServiceState_Number((int) 17013L),
  TripAlarmType_OutOfServiceState_EffectiveDisplayName((int) 17014L),
  TripAlarmType_OutOfServiceState_TransitionTime((int) 17015L),
  TripAlarmType_OutOfServiceState_EffectiveTransitionTime((int) 17016L),
  TripAlarmType_OutOfServiceState_TrueState((int) 17017L),
  TripAlarmType_OutOfServiceState_FalseState((int) 17018L),
  TripAlarmType_SilenceState((int) 17019L),
  TripAlarmType_SilenceState_Id((int) 17020L),
  TripAlarmType_SilenceState_Name((int) 17021L),
  TripAlarmType_SilenceState_Number((int) 17022L),
  TripAlarmType_SilenceState_EffectiveDisplayName((int) 17023L),
  TripAlarmType_SilenceState_TransitionTime((int) 17024L),
  TripAlarmType_SilenceState_EffectiveTransitionTime((int) 17025L),
  TripAlarmType_SilenceState_TrueState((int) 17026L),
  TripAlarmType_SilenceState_FalseState((int) 17027L),
  TripAlarmType_AudibleEnabled((int) 17028L),
  TripAlarmType_AudibleSound((int) 17029L),
  TripAlarmType_OnDelay((int) 17034L),
  TripAlarmType_OffDelay((int) 17035L),
  TripAlarmType_FirstInGroupFlag((int) 17036L),
  TripAlarmType_ReAlarmTime((int) 17039L),
  TripAlarmType_ReAlarmRepeatCount((int) 17040L),
  TripAlarmType_ShelvingState_AvailableStates((int) 17698L),
  TripAlarmType_ShelvingState_AvailableTransitions((int) 17699L),
  TripAlarmType_AudibleSound_ListId((int) 17963L),
  TripAlarmType_AudibleSound_AgencyId((int) 17964L),
  TripAlarmType_AudibleSound_VersionId((int) 17965L),
  TripAlarmType_LatchedState((int) 18337L),
  TripAlarmType_LatchedState_Id((int) 18338L),
  TripAlarmType_LatchedState_Name((int) 18339L),
  TripAlarmType_LatchedState_Number((int) 18340L),
  TripAlarmType_LatchedState_EffectiveDisplayName((int) 18341L),
  TripAlarmType_LatchedState_TransitionTime((int) 18342L),
  TripAlarmType_LatchedState_EffectiveTransitionTime((int) 18343L),
  TripAlarmType_LatchedState_TrueState((int) 18344L),
  TripAlarmType_LatchedState_FalseState((int) 18345L),
  TripAlarmType_Suppress2_InputArguments((int) 24459L),
  TripAlarmType_Unsuppress2_InputArguments((int) 24461L),
  TripAlarmType_RemoveFromService2_InputArguments((int) 24463L),
  TripAlarmType_PlaceInService2_InputArguments((int) 24465L),
  TripAlarmType_Reset2_InputArguments((int) 24467L),
  TripAlarmType_ShelvingState_TimedShelve2_InputArguments((int) 24931L),
  TripAlarmType_ShelvingState_Unshelve2_InputArguments((int) 24933L),
  TripAlarmType_ShelvingState_OneShotShelve2_InputArguments((int) 24935L),
  TripAlarmType_GetGroupMemberships_OutputArguments((int) 25171L),
  TripAlarmType_SupportsFilteredRetain((int) 32239L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableTrip> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableTrip value : OpcuaNodeIdServicesVariableTrip.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableTrip(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableTrip enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
